﻿using System.Text.Json.Serialization;
// ReSharper disable FieldCanBeMadeReadOnly.Global
// ReSharper disable ConvertToConstant.Global

namespace OBSBlur;

public struct Config
{
    [JsonRequired]
    public string ObsWebsocketUrl = "ws://localhost:4444";
    [JsonRequired]
    public string ObsWebsocketPassword = "";
    [JsonRequired]
    public string[] EnabledScenes = { "Desktop" };
    [JsonRequired]
    public string[] BlurPrograms = { "Discord", "thunderbird", "Signal" };
    [JsonRequired]
    public string[] BlurWindows = { "Task Switching" };
    [JsonRequired]
    public string DisplayCaptureName = "Display Capture";

    public Config()
    {
    }

    public override string ToString()
    {
        return
            $"Websocket-Url='{ObsWebsocketUrl}\n" +
            $"Websocket-Password='{new string(ObsWebsocketPassword.Substring(Math.Min(3, ObsWebsocketPassword.Length)).Concat(new string('*', Math.Max(3, ObsWebsocketPassword.Length)+6)).ToArray())}'\n" +
            $"Enabled Scenes={{{string.Join(',', EnabledScenes)}}}\n" +
            $"Blur Programs={{{string.Join(',', BlurPrograms)}}}\n" +
            $"Blur Windows={{{string.Join(',', BlurWindows)}}}\n" +
            $"Display Capture Name='{DisplayCaptureName}'";
    }
}