﻿using System.Runtime.InteropServices;

namespace OBSBlur.Window;

[StructLayout(LayoutKind.Sequential)]
public struct Point
{
    public int X;
    public int Y;

    // ReSharper disable once MemberCanBePrivate.Global
    public Point(int x, int y)
    {
        this.X = x;
        this.Y = y;
    }

    public static implicit operator System.Drawing.Point(Point p)
    {
        return new System.Drawing.Point(p.X, p.Y);
    }

    public static implicit operator Point(System.Drawing.Point p)
    {
        return new Point(p.X, p.Y);
    }

    public override string ToString()
    {
        return $"{{X={X,-6:####0}, Y={Y,-6:####0}}}";
    }

    public override bool Equals(object? obj)
    {
        return obj is Point other && Equals(other);
    }

    public bool Equals(Point other)
    {
        return X == other.X && Y == other.Y;
    }

    public override int GetHashCode()
    {
        return HashCode.Combine(X, Y);
    }
}